//==========================================================================
//     Loesen eines Gleichungssystems
//      bei vorliegender LDLT-Faktorisierung
//==========================================================================
#include "ls.h"
void ls_ldlt_solve(int n,      // Dimension der Matrix
                   int d,      // hoechster Index einer Nebendiagonalen
                   REAL *A,    // LDLT-Zerlegung; auf dem unteren Dreieck
                               // steht die Matrix L
                   REAL *diag, // Diagonalelemente der Diagonalmatrix D
                   REAL *b)    // rechte Seite des Gleichungssystems
                               // O: Loesungsvektor
{  int i,j,na,ne; REAL *a,*aa,s;
   for(i=0,a=A;i<n;b[i++]=b[i]-s,a+=n)
   {  na=(i-d<1)?0:i-d-1;for(s=0,j=na;j<i;s+=a[j]*b[j],j++);}
   for(j=n,a=A+n*n-n;j-->0;b[j]=(b[j]/diag[j])-s,a-=n)
   { ne=(i+d+1>n)?n:i+d+1;for(s=0,aa=a+n,i=j;++i<ne;s+=aa[j]*b[i],aa+=n);}
}
