//==========================================================================
//              Loesen eines linearen Gleichungssystems
//       mit symmetrischer,positiv definiter Koeffizientenmatrix
//                       mit dem cg-Verfahren
// Rueckkehrcode: Iterationzahl.
//==========================================================================
#include "ls.h"
int ls_sym_cg(int n,    // Dimension der Matrix
              REAL *A,  // Koeffizientenmatrix (oberes Dreieck wird genutzt)
              REAL *b)  // rechte Seite
                        // O: Loesungsvektor
{ INT i,k,rc=0; REAL s,*p,*w,*aa,*bb,*x,a=1,epscg=1.e-10,ppa,ppn,rra,rrn,wp;
  p=new REAL[n+n+n];w=p+n;x=w+n;
  for(i=0,rra=0;i<n;rra+=b[i]*b[i],x[i++]=0);
  for(i=0;i<n;p[i++]=b[i]);
  while(1)
  { for(k=0,aa=A;k<n;w[k++]=s,aa+=n)
    { for(i=0,bb=A+k,s=0;i<k;s+=*bb*p[i++],bb+=n);
      for(i=k;i<n;s+=aa[i]*p[i],i++);}
    for(i=0,wp=0;i<n;wp+=p[i]*w[i],i++);a=rra/wp;
    for(i=0,rrn=0;i<n;x[i]+=a*p[i],b[i]-=a*w[i],rrn+=b[i]*b[i],i++);
    if(ausl(rra,rrn)<epscg){ memcpy(b,x,n*sizeof(REAL));break;}
    rc++,a=rrn/rra;for(i=0;i<n;p[i++]=b[i]+a*p[i]);rra=rrn;}
  delete [] p;return(rc);
}
