//==========================================================================
//  Polynomwertberechnung mittels Langrange-schem Interpolationspolynom
//                 und seiner baryzentrischen Darstellung
// Rueckkehrcode: Polynomwert
//==========================================================================
#define REAL double
#include<math.h>
#include<stdlib.h>
REAL lpolynom(int n,    // Stuetzstellen-Anzahl
              REAL *x,  // Feld mit den x-Werten der Stuetzstellen
              REAL *y,  // Feld mit den y-Werten der Stuetzstellen
              REAL t)   // Argument fuer den Polynomwert
{ static REAL *a=NULL,s,ss,z,epslpolynom=1.e-10;
  int nn=0,i,j;
  if(n!=nn)
  { if(a) delete []a;if(!n) return(0);
    a=new REAL[n];nn=n;
    for(i=0;i<n;a[i++]=1/s)
      for(s=1,ss=x[i],j=0;j<n;j++) if(j!=i) s*=(ss-x[j]);}
  for(i=0;i<n;i++) if(fabs(t-x[i])<epslpolynom) return(y[i]);
  for(i=0,s=ss=0;i<n;z=a[i]/(t-x[i]),s+=y[i++]*z,ss+=z);
  return(s/ss);
}
