//==========================================================================
//      Erhard-Schmidt-sches Orthogonalisierungsverfahren
// Rueckkehrcode: Anzahl der orthonormierten Spalten.
//==========================================================================
#include "ls.h"
int ls_ortho(int m,   // Zeilenanzahl
             int n,   // Spaltenanzahl
             REAL *A) // (m,n)-Matrix; O: orthonormierte Spalten
{ int i,l,rc=0;REAL epsortho=1.e-10,s,*x=new REAL[n],*a,*ae=A+m*n;
  for(l=0;l<n;l++)
  { for(i=0;i<l;i++)
    { if(!x[i]) continue;for(a=A,s=0;a<ae;s+=a[i]*a[l],a+=n);
      for(a=A,s*=-x[i];a<ae;a[l]+=a[i]*s,a+=n);}
    for(a=A,s=0;a<ae;s+=a[l]*a[l],a+=n);x[l]=(s>epsortho)?1/s:0;}
  for(i=0;i<n;i++)
    if(x[i]) for(a=A,s=sqrt(x[i]);a<ae;a[i]*=s,a+=n);
    else for(a=A;a<ae;a[i]=0,a+=n);
  delete [] x;return(n-rc);
}
