//==========================================================================
//               Loesen eines linearen Gleichungssystems
//               bei unsymmetrischer Koeffizientenmatrix
//                      mit dem cg-Verfanren
// Rueckkehrcode: Iterationzahl.
//==========================================================================
#include "ls.h"
int ls_usym_cg(int m,   // Zeilenzahl der Matrix
               int n,   // Spaltenzahl der Matrix
               REAL *A, // Koeffizientenmatrix
               REAL *b) // rechte Seite
                        // O: Loesungsvektor
{ INT i,k,mn,rc=0;
  REAL s,*p,*w,*aa,*bb,*x,a=1,epscg=1.e-10,ppa,ppn,rra,rrn,wp;
  mn=(m>n)?m:n;p=new REAL[mn+n+n];w=p+n;x=w+mn;
  for(k=0;k<n;p[k++]=s)
    for(s=0,aa=A+k,i=0;i<m;s+=*aa*b[i++],aa+=n);
  for(k=0,ppa=0;k<n;ppa+=p[k]*p[k],k++);
  while(1)
  { for(i=0,aa=A;i<m;w[i++]=s,aa+=n)
      for(s=0,k=0;k<n;s+=aa[k]*p[k],k++);
    a=rra/ppa;
    for(k=0;k<n;x[k]+=a*p[k],k++);
    for(i=0,rrn=0;i<m;b[i]-=a*w[i],rrn+=b[i]*b[i],i++);
    if(ausl(rrn,rra)<epscg){ memcpy(b,x,sizeof(REAL)*n);break;}
    rc++,a=rrn/rra;
    for(k=0;k<n;w[k++]=s)
      for(s=0,aa=A+k,i=0;i<m;s+=*aa*b[i++],aa+=n);
    for(k=0,ppn=0;k<n;p[k]=w[k]+a*p[k],ppn+=p[k]*p[k],k++);
    rra=rrn,ppa=ppn;}
  delete []p;return(rc);
}
