//==========================================================================
//     Polynomwertberechnung mittels Newtonschem Interpolationspolynom
// Rueckkehrcode: Polynomwert
//==========================================================================
#define REAL double
#include<stdlib.h>
REAL npolynom(int n,    // Stuetzstellen-Anzahl
              REAL *x,  // Feld mit den x-Werten der Stuetzstellen
              REAL *y,  // Feld mit den y-Werten der Stuetzstellen
              REAL t)   // Argument fuer den Polynomwert
{ static REAL *a=NULL,s;static int nn=0,i,j;
  if(n!=nn)
  { if(a) delete []a;if(!n) return(0);
    a=new REAL[n];for(i=0;i<n;a[i++]=y[i]);nn=n;
    for(i=n-1;i;i-=2)
      for(j=i,s=x[i-1];j<n;a[j++]=(a[j]-a[j-1])/(x[j]-s));}
  for(i=n-1,s=a[i];i--;s=s*(t-x[i])+a[i]);
  return(s);
}
